
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var yarip = {};

Cu.import("resource://yarip/yarip.jsm", yarip);
Cu.import("resource://yarip/loader.jsm");

var loader = new YaripLoader();

function handleEvent(event) {
    switch(event.type) {
    case "DOMContentLoaded":
        var location = yarip.getLocationFromLocation(content.document.location);
        sendAsyncMessage("Yarip:LoaderRequest", { "location": location });
        break;
    }
}

// message = {
//   name:    %message name%,
//   target:  %the target of the message%
//   sync:    %true or false%,
//   json:    %json object or null%
//   objects: %an array of objects sent using sendSyncMessage% (NOTE, DO NOT USE THIS. .objects will change!)
// }
function receiveMessage(message) {
    switch(message.name) {
    case "Yarip:LoaderResponse":
        var obj = message.json;
        if (!obj.yaripEnabled) return;
        if (!obj.pageName || !obj.addressObj) return;

        var doc = content.document;
        var pageName = obj.pageName;
        var addressObj = obj.addressObj;
        if (!doc || !doc.body || !doc.location) return;
        if (!/^https?:$/.test(doc.location.protocol)) return;
        if (!/^(text\/html|application\/xhtml\+xml)$/.test(doc.contentType)) return;

        loader.load(doc);
        break;
    }
}

addEventListener("DOMContentLoaded", handleEvent, false);
addMessageListener("Yarip:LoaderResponse", receiveMessage);

