
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var AS = Cc["@mozilla.org/alerts-service;1"].getService(Ci.nsIAlertsService);

function YaripOverlay()
{
    this.toggleEnabled = function(enabled)
    {
        this.enabledObserver.disable();
        yarip.toggleEnabled(enabled);
        this.enabledObserver.enable();
    }

    this.updateEnabled = function()
    {
        this.toggleEnabled(yarip.getValue(yarip.PREF_ENABLED, true, yarip.DATA_TYPE_BOOLEAN), true);
    }

    this.handleEvent = function(event)
    {
        switch(event.type) {
        case "load":
            this.enabledObserver = new YaripObserver(
                yarip.PREF_ENABLED,
                function() { yaripOverlay.updateEnabled(); }
            );
            this.schemesObserver = new YaripObserver(
                yarip.PREF_SCHEMES,
                function() {
                    yarip.setSchemes(yarip.getValue(yarip.PREF_SCHEMES, "", yarip.DATA_TYPE_STRING));
                }
            );
            window.messageManager.addMessageListener("Yarip:LoaderRequest", this);
            window.messageManager.loadFrameScript("chrome://yarip/content/mobileFrameScript.js", true);
            yarip.injectCSS("chrome://yarip/skin/blacklist.css", true);
            break;
        }
    }

    // message = {
    //   name:    %message name%,
    //   target:  %the target of the message%
    //   sync:    %true or false%,
    //   json:    %json object or null%
    //   objects: %an array of objects sent using sendSyncMessage% (NOTE, DO NOT USE THIS. .objects will change!)
    // }
    this.receiveMessage = function(message)
    {
        if (!/^Yarip:/.test(message.name)) return;

        switch(message.name) {
        case "Yarip:LoaderRequest":
            var browser = message.target;
            var location = message.json.location;
            var obj = null;
            if (yarip.enabled) {
                var pageName = yarip.getPageName(location, yarip.MODE_PAGE);
                var addressObj = yarip.getAddressObj(pageName, true);
                obj = {
                    "yaripEnabled": true,
                    "pageName": pageName,
                    "addressObj": addressObj
                }
            } else {
                obj = { "yaripEnabled": false }
            }
            browser.messageManager.sendAsyncMessage("Yarip:LoaderResponse", obj);
            break;
        }

        AS.showAlertNotification(null, "Yarip", message.name + " " + location.href, false, "", null);
    }
}

