
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function YaripObserver(preference, callback)
{
    this.observable = null;
    this.enabled = true;
    this.root = null;
    this.value = null;

    this.register = function()
    {
        if (!preference || !callback) return;

        var index = preference.lastIndexOf(".");
        this.root = preference.substring(0, index + 1);
        this.value = preference.substring(index + 1);

        var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        this.observable = prefService.getBranch(this.root);
        this.observable.QueryInterface(Components.interfaces.nsIPrefBranch2);
        this.observable.addObserver("", this, false);
    }

    this.unregister = function()
    {
        if (this.observable) {
            this.observable.removeObserver("", this);
        }
    }

    this.observe = function(subject, topic, data)
    {
        if (!this.enabled || data != this.value) return;

        this.disable();
        callback();
        this.enable();
    }

    this.enable = function()
    {
        this.enabled = true;
    }

    this.disable = function()
    {
        this.enabled = false;
    }

    this.register();
}
